config/routes.rb
Everest::Application.routes.draw do
  resources :achievements

  resources :towers
  resources :sessions
  resources :users
  resources :climbs

  get "pages/index"

  get "register" => "users#new", :as => "register"
  get "login" => "users#login", :as => "login"
  get "logout" => "sessions#destroy"
  get "profile" => "users#profile"
  get "about" => "pages#about"

  match 'auth/:provider/callback', to: 'sessions#create_omniauth'
  match 'auth/failure', to: redirect('/')

  root :to => 'pages#index'

end

app/models/climb.rb
class Climb < ActiveRecord::Base
  belongs_to :tower
  belongs_to :user
  attr_accessible :tower, :tower_id, :user, :user_id, :distance, :created_at, :time

  validates :distance, :presence => true
  validates_numericality_of :distance, :greater_than => 0

  def steps
    (self.distance / self.tower.step_height).round
  end
end

app/controllers/climbs_controller.rb
class ClimbsController < ApplicationController
  # GET /climbs

  def index
    @climbs = Climb.all

    respond_to do |format|
      format.html
      format.json { render json: @climbs }
    end
  end

  def show
    @climb = Climb.find(params[:id])
    respond_to do |format|
      format.html 
      format.json { render json: @climb }
    end
  end

  def new
    @climb = Climb.new
    @floors = '[{"from": 1, "to": 2, "stepsPerFloor": 20}, {"from": 2, "to": 43, "stepsPerFloor": 20}]'

    respond_to do |format|
      format.html 
      format.json { render json: @climb }
    end
  end

  # Disable editing for now
  #def edit
  #  @climb = Climb.find(params[:id])
  #end

  def create
    @climb = Climb.new(params[:climb])
    @climb.user_id = current_user.id
    respond_to do |format|
      if @climb.save
        logger.info "Added new climb: #{@climb.user_id} climbed #{@climb.tower_id}"
        @climb.user.total_distance += @climb.distance
        @climb.user.save!
        format.html { redirect_to @climb, notice: "Climb was succesfully created." }
        format.json { render json: @climb, status: :created, location: @climb }
      else
        format.html { render action: "new" }
        format.json { render json: @climb.errors, status: :unprocessable_entity }
      end
    end
  end

  def update
    @climb = Climb.find(params[:id])

    respond_to do |format|
      if @climb.update_attributes(params[:tower])
        format.html { redirect_to @climb, notice: 'Tower was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: "edit" }
        format.json { render json: @climb.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /towers/1
  # DELETE /towers/1.json
  def destroy
    @climb = Climb.find(params[:id])
    @climb.user.total_distance -= @climb.distance
    @climb.user.save!
    @climb.destroy

    respond_to do |format|
      format.html { redirect_to climbs_url }
      format.json { head :no_content } end
  end
end

app/helpers/climb_helper.rb
module ClimbHelper
end

app/views/climbs/_form.html.erb
<%= form_for @climb, :html => { :multipart => true } do |f| %>
  <% if @climb.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@climb.errors.count, "error") %> prohibited this climb from being saved:</h2>

      <ul>
      <% @climb.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <%= hidden_field(:climb, :user_id, :value => current_user.id) %>
  <div class="field">
    <%= f.label :tower %><br />
    <%= collection_select(:climb, :tower_id, Tower.all, :id, :name) %>
  </div>
  <div class="field">
    <%= f.label "distance (in meters)" %>
    <%= f.text_field :distance %>
  </div>
  <div class="field">
  Add a time: <%= check_box_tag 'add_time', 'yes', false, :class => 'addtime' %>
      <div class="field time" style="display:none">
        <%= f.label "time (in seconds)" %>
        <%= f.text_field :time %>
      </div>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/climbs/edit.html.erb
<h1>Editing tower</h1>

<%= render 'form' %>
<%= link_to 'Show', @climb %> |
<%= link_to 'Back', climbs_path %>

app/views/climbs/index.html.erb
<h1>Recent Climbs</h1>

<ul>
  <% @climbs.each do |climb| %>
    <li><%= climb.user.name %> climbed <%= climb.tower.name %></li>
  <% end %>
</ul>
<br />

<%= link_to 'New Climb', new_climb_path %>

app/views/climbs/new.html.erb
<h1>New Climb</h1>
<%= render 'form' %>
<div id="stairs">
</div>
<script>
  <% if @floors %>
      var test = <%= raw @floors %>;
  <% end %>
</script>
<%= javascript_include_tag "towers" %>

app/views/climbs/show.html.erb
<h2><%= @climb.user.name %>'s climb of <%= @climb.tower.name %></h2>
<%= link_to @climb.tower.name, @climb.tower %>